BEGIN   { code = 0
          codeno = 0
          codechunkno = 1

          definitions = ":def:|:edef:|:xdef:|:gdef:"\
             ":let:|"\
             ":chardef:|:mathchardef:|"\
             ":newcount:|:countdef:|"\
             ":newdimen:|:dimendef:|"\
             ":newskip:|:skipdef:|"\
             ":newtoks:|:toksdef:|"\
             ":muskipdef:|"\
             ":newif:|"\
             ":newbox:|"\
             ":read:"\
             ":font:"

          print "\\input tweb.sty\n\n"\
           "\\expandafter\\def\\csname chunk:0\\endcsname{}\n\n"\
           "{\\catcode`\\| = 0 |catcode`|\\ = 12 %\n"\
           "|obeylines |gdef|ttfinish#1\\edoc{|gobblespace#1|endgroup}}\n\n"\
           "\\makeindexes\n"
}

END   { print "\n\n\\printuserleveldefs\n"\
              "\\printdefs\n"\
              "\\printchunks\n\n\\bye"
}


/^@text %%% *version *= *"\$Id: */ \
{
      gsub(/^@text %%% *version *= *"\$Id: */, "")
      gsub(/[ $",]*$/, "")
      printf "\n\\gdef \\RCS {%s}", $0
      printf "\n\\gdef \\RCSversion {%s}\n", $2
      next
}

/^@file /       { printf "\\def\\filename{%s}\n\n", substr($0,7) ; next }

/^@quote$/      { printf "\|"  ; next }
/^@endquote$/   { printf "\|"  ; next }

/^@begin code/  { 
                  print "\\bigbreak"\
                        "\\begingroup\n"\
                        "\\obeylines"
                  code = 1
                  codeno = $3
                  next
                }
/^@end code/    { 
                  print "\\endgroup\n\\codebreak"
                  code = 0
                  next
                }

/^@begin docs/  { 
                  printf "\\bigbreak\n"\
                         "\\begingroup\n"\
                         "\\makeactive\\\|\n"
                  next
                }
/^@end docs/    { printf "\\endgroup\n" ; next }

/^@defn /       { 
                  gsub(/\[\[/, "\\code "); gsub(/]]/, "\\edoc")
                  name = substr($0,7)
                  defs[name] += 1
                  printf "\\refchunk{chunk:%d}", used[name]
                  printf "\\noindent\\LA %s\\RA", name

                  if (defs[name] > 1)
                     printf "$+\\!\\!\\equiv$"
                  else
                     printf "$\\equiv$"

                  gsub("@", "\"@", name)
                  printf "\%\n\\chk{%s@\\LA %s\\RA}"\
                         "\n\\par\\smallkern\\nobreak", name, name

                  next
                }
/^@use /        { 
                  gsub(/\[\[/, "\\code "); gsub(/]]/, "\\edoc")
                  name = substr($0,6)
                  used[name] = codeno
                  printf "\\LA %s\\RA", name
                  gsub("@", "\"@", name)
                  printf "\%\n\\chk{%s@\\LA %s\\RA}", name, name
                  printf "\%\n\\pageref{chunk:%d}\n", used[name]

                  getline
                  next
                }

/^@literal /    { printf "%s", substr($0, 10) ; next }

/^@nl$/         { printf "\n" ; next }

/^@text /       { line = junk = substr($0,7)
                  indexed = ""
                  found = ""

                  if (code)   
                  {
                     while (match(junk, /\\[a-zA-Z@]+/)>0\
                         && substr(junk, 1, RSTART) !~ /%/) 
                     {
                        prefix = "\\ddx{"

                        found = substr(junk, RSTART+1, RLENGTH-1)
                        junk = substr(junk, RSTART+RLENGTH)

                        if ( ":" found ":" ~ definitions ) 
                        {
                           prefix = "\\udx{"
                           match(junk, /\\[a-zA-Z@]+|\\[^a-zA-Z@]/)
                           found = substr(junk, RSTART+1, RLENGTH-1)
                           junk = substr(junk, RSTART+RLENGTH)
                        }

                        if (found != "" && found !~ /[^a-zA-Z@]/) 
                        {
                           gsub("@", "\"@", found)
                           indexed = "\%\n"\
                              prefix found\
                              "@\\\\" found "\|ino{"\
                              codechunkno "}}" indexed
                        }
                     }
                     printf "\\no{%d}\\code %s\\edoc%s",\
                         codechunkno++, line, indexed 
                  }
                  else   
                     printf "%s", line
               }
